//
//  GradientBGView.swift
//  NearbyStores
//
//  Created by DT Team on 5/19/18.
//  Copyright © 2018 Amine. All rights reserved.
//

import UIKit

@IBDesignable
class GradientBGView: UIView {

    
    @IBInspectable var startColor:   UIColor = .black { didSet { updateColors() }}
    @IBInspectable var endColor:     UIColor = .white { didSet { updateColors() }}
    @IBInspectable var startLocation: Double =   0.05 { didSet { updateLocations() }}
    @IBInspectable var endLocation:   Double =   0.95 { didSet { updateLocations() }}
    @IBInspectable var horizontalMode:  Bool =  false { didSet { updatePoints() }}
    @IBInspectable var diagonalMode:    Bool =  false { didSet { updatePoints() }}
    
    override class var layerClass: AnyClass { return CAGradientLayer.self }
    
    var gradientLayer: CAGradientLayer { return layer as! CAGradientLayer }
    
    func updatePoints() {
        if horizontalMode {
            gradientLayer.startPoint = diagonalMode ? CGPoint(x: 1, y: 0) : CGPoint(x: 0, y: 0.5)
            gradientLayer.endPoint   = diagonalMode ? CGPoint(x: 0, y: 1) : CGPoint(x: 1, y: 0.5)
        } else {
            gradientLayer.startPoint = diagonalMode ? CGPoint(x: 0, y: 0) : CGPoint(x: 0.5, y: 0)
            gradientLayer.endPoint   = diagonalMode ? CGPoint(x: 1, y: 1) : CGPoint(x: 0.5, y: 1)
        }
    }
    func updateLocations() {
        gradientLayer.locations = [startLocation as NSNumber, endLocation as NSNumber]
    }
    func updateColors() {
        gradientLayer.colors    = [startColor.cgColor, endColor.cgColor]
    }
    
//    
//    func updateLocations() {
//        
//        if Utils.isRTL(){
//            gradientLayer.locations = [endLocation as NSNumber, startLocation as NSNumber]
//        }else{
//            gradientLayer.locations = [startLocation as NSNumber, endLocation as NSNumber]
//        }
//        
//    }
//    
//    func updateColors() {
//        
//        if Utils.isRTL(){
//            gradientLayer.colors    = [endColor.cgColor,startColor.cgColor]
//        }else{
//            gradientLayer.colors    = [startColor.cgColor, endColor.cgColor]
//        }
//        
//    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        updatePoints()
        updateLocations()
        updateColors()
    }

}
