//
//  SignUpViewController.swift
//  NearbyStores
//
//  Created by DT Team on 5/20/18.
//  Copyright © 2018 Amine. All rights reserved.
//

import UIKit
import SVProgressHUD
import SwiftEventBus
import SwiftIcons
import SkyFloatingLabelTextField
import SVProgressHUD
import FirebaseAuth
import RealmSwift


protocol SignUpControllerDelegate {
    func signupSuccess(controller: SignUpViewController, user: User)
    func signupFaild(controller: SignUpViewController)
}

class SignUpViewController: UIViewController, UserLoaderDelegate,  UITextFieldDelegate, UIImagePickerControllerDelegate, UINavigationControllerDelegate {

    var delegate: SignUpControllerDelegate? = nil
    
    
    @IBOutlet weak var navigationBar: UINavigationBar!
    @IBOutlet weak var navigationBarItem: UINavigationItem!
    
    func setupNavBarButtons() {
           
           //arrow back icon
           var arrowImage: UIImage? = nil
           if Utils.isRTL(){
               arrowImage = UIImage.init(icon: .ionicons(.iosArrowForward), size: CGSize(width: 30, height: 30), textColor: Colors.darkColor)
           }else{
               arrowImage = UIImage.init(icon: .ionicons(.iosArrowBack), size: CGSize(width: 30, height: 30), textColor: Colors.darkColor)
           }
           
           let customBarButtonItem = UIBarButtonItem(image: arrowImage!, style: .plain, target: self, action: #selector(onBackHandler))
        customBarButtonItem.setIcon(icon: .ionicons(.iosArrowBack), iconSize: 25, color: UIColor.black)
       
           navigationBarItem.leftBarButtonItems = []
           navigationBarItem.rightBarButtonItems = []
           navigationBarItem.leftBarButtonItems?.append(customBarButtonItem)
        
           
    }
         

    @IBOutlet weak var signinBtn: CustomButton!
    
    
    @IBOutlet weak var constraintScrollBottom: NSLayoutConstraint!
    @IBOutlet weak var scrollview: UIScrollView!
    
    
    @IBOutlet weak var stackView_phoneNumber: UIStackView!
    @IBOutlet weak var stackViewUser: UIStackView!
    
    @IBOutlet weak var full_name_field: SkyFloatingLabelTextField!
    @IBOutlet weak var email_field: SkyFloatingLabelTextField!
    @IBOutlet weak var login_field: SkyFloatingLabelTextField!
    @IBOutlet weak var password_field: SkyFloatingLabelTextField!
    @IBOutlet weak var orLabel: UILabel!
    @IBOutlet weak var pick_photo_btn: UIButton!
    @IBOutlet weak var photo_profile: UIImageView!
    
    @IBOutlet weak var signUpBtn: UIButton!
    
    @IBAction func onPickPhotoAction(_ sender: Any) {
        
        imagePicker.allowsEditing = false
        imagePicker.sourceType = .photoLibrary
        
        self.present(imagePicker, animated: true)
      
    }
    
    
    @IBAction func signUpAction(_ sender: Any) {
        
        doSignup()
     
    }
    
    
    @objc func onBackHandler()  {
        
        if stackView_phoneNumber.isVisible(){
            self.stackViewUser.isHidden = false
            self.stackView_phoneNumber.isHidden = true
        }else{
            if let controller = self.navigationController{
                //controller.navigationBar.isHidden = true
                controller.popViewController(animated: true)
                ////controller.navigationBar.isHidden = false
            }else{
                self.dismiss(animated: true)
            }
        }
           
    }
    
    
    var imageId: String = ""
    
    let imagePicker = UIImagePickerController()
    
    
    @IBOutlet weak var top_rounded_view: UIView!
    @IBOutlet weak var bottom_rounded_view: UIView!
    
    
    
    @IBOutlet weak var top_rounded_view0: UIView!
    @IBOutlet weak var bottom_rounded_view0: UIView!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
      
        
        self.top_rounded_view.roundCorners(corners: [.topLeft, .topRight], radius: 20)
        self.bottom_rounded_view.roundCorners(corners: [.bottomLeft, .bottomRight], radius: 20)
        
        self.top_rounded_view0.roundCorners(corners: [.topLeft, .topRight], radius: 20)
        self.bottom_rounded_view0.roundCorners(corners: [.bottomLeft, .bottomRight], radius: 20)
        
        
        
        imagePicker.delegate = self
        
        setupView()
        
        
        NotificationCenter.default.addObserver(self, selector: #selector(handleKeyboardNotification), name: UIResponder.keyboardWillHideNotification, object: nil)
        
        NotificationCenter.default.addObserver(self, selector: #selector(handleKeyboardNotification), name: UIResponder.keyboardWillShowNotification, object: nil)
        
        
        self.navigationBar.isTranslucent = true
        self.navigationBar.setBackgroundImage(UIImage(), for: UIBarMetrics.default)
        self.navigationBar.shadowImage = UIImage()
        self.navigationBar.tintColor = .white
             
        setupNavBarButtons()

    }
    
    @objc func handleKeyboardNotification(notification: NSNotification) {
        
        
        if let userInfo = notification.userInfo {
            
            let keyboardFrame = userInfo[UIResponder.keyboardFrameEndUserInfoKey] as! CGRect
            let isKeyboardShowing = notification.name == UIResponder.keyboardWillShowNotification
            
            
            if let textField = self.lastTextField, let _ = textField.superview?.convert(textField.frame, to: nil) {
            
                if isKeyboardShowing{
                    // so increase contentView's height by keyboard height
                    self.constraintScrollBottom.constant = keyboardFrame.height
                    UIView.animate(withDuration: 0, delay: 0, options: UIView.AnimationOptions.curveEaseOut, animations: {
                        self.view.layoutIfNeeded()
                    })

                }else{
                    // so increase contentView's height by keyboard height
                     self.constraintScrollBottom.constant = 0
                    UIView.animate(withDuration: 0, delay: 0, options: UIView.AnimationOptions.curveEaseOut, animations: {
                        self.view.layoutIfNeeded()
                    })

                }
                
                
            
            }
            
            
            
        }
    
        
    }


    
    @IBAction func haveAccountBtn(_ sender: Any) {
        
        dismiss(animated: true, completion: nil)
        
    }
    
   

    @IBOutlet weak var phone_number_field: SkyFloatingLabelTextField!
    @IBOutlet weak var code_verification_field: SkyFloatingLabelTextField!
    
    
    @IBOutlet weak var get_code_btn: CustomButton!
    @IBOutlet weak var verify_code_btn: CustomButton!
    
    @IBOutlet weak var code_verification_field_container: UIView!
    @IBOutlet weak var verify_code_btn_container: UIView!
    
    
    @IBAction func get_code_action(_ sender: Any) {
        
        get_code()
        
    }
    
    @IBAction func verify_code_action(_ sender: Any) {
        
        guard let code_v_field = code_verification_field.text else{
            return
        }
        
        if( code_v_field == ""){
            let message: [String:String] = ["alert":"The code verification field is empty!".localized]
            self.showAlertError(title: "Alert!".localized, content: message, msgBnt: "OK".localized)
            return
        }
        
        MyProgress.show(parent: view)
        
        let verificationID =  LocalData.getValue(key: "authVerificationID", defaultValue: "")
        let phoneNumber =  LocalData.getValue(key: "phoneNumber", defaultValue: "")
      
        let credential = PhoneAuthProvider.provider().credential(withVerificationID: verificationID ,
                                                                       verificationCode: code_v_field)
            Auth.auth().signInAndRetrieveData(with: credential) { authData, error in
                
                MyProgress.dismiss()
                
             if let error = error {
                let message: [String:String] = ["AuthError": error.localizedDescription]
                self.showAlertError(title: "Alert!".localized, content: message, msgBnt: "OK".localized)
                return
              }
                
             //update phone number
             Utils.printDebug("\( authData!.user)")
                
                if let user = self.created_user{
                    self.update_phone(user_id: user.id, phone: phoneNumber)
                }
                
         };
        
    }
    
    func update_phone(user_id: Int,phone: String) {
        
        
        MyProgress.show(parent: self.view)
        
        
        let api = SimpleLoader()
        
        
        let parameters = [
            "user_id"       : String(user_id),
            "phone"       : String(phone),
        ]
        
        api.run(url: Constances.Api.API_UPDATE_PHONE, parameters: parameters) { (parser) in
            
            
            MyProgress.dismiss()
            
            if parser?.success == 1{
                
                //open main activity
                
            
                let realm = try! Realm()
                realm.beginWrite()
                self.created_user?.phone = phone
                try! realm.commitWrite()
                
            
                Session.createSession(user: self.created_user!)
                SwiftEventBus.post("on_main_refresh", sender: self.created_user)
               
                
                if let del = self.delegate{
                    del.signupSuccess(controller: self, user: self.created_user!)
                }else{
                     if MainViewController.mInstance != nil {
                        self.dismiss(animated: true)
                    }else{
                        self.startMainVC()
                    }
                }
               
            }
        }
       

        
    }
    
    func get_code() {
        
        
        guard let phone_field = phone_number_field.text, phone_field != "" else{
            phone_number_field.errorMessage = "Invalid phone".localized
            return
        }
      
        
        let phone = phone_field.replacingOccurrences(of: " ", with: "", options: .literal, range: nil)
        let result = phone.isValid(regex: .phone)
        
        if !result {
            phone_number_field.errorMessage = "Invalid phone".localized
            return
        }

         MyProgress.show(parent: self.view)
    
        PhoneAuthProvider.provider().verifyPhoneNumber(phone) { (verificationID,error) in
            
            MyProgress.dismiss()
            
            if let error = error {
                let message: [String:String] = ["AuthError": error.localizedDescription]
                self.showAlertError(title: "Alert!".localized, content: message, msgBnt: "OK".localized)
                
                return
            }
            
            // Sign in using the verificationID and the code sent to the user
            // ...
            
            LocalData.setValue(key: "authVerificationID", value: verificationID!)
            LocalData.setValue(key: "phoneNumber", value: phone)
            
            self.code_verification_field_container.isHidden = false
            self.verify_code_btn_container.isHidden = false
            
        }
    }
    
    
    func setup_phone_number_component() {
        
        phone_number_field.keyboardType = .phonePad
        phone_number_field.textColor = UIColor.black
        phone_number_field.lineColor = UIColor.gray
        phone_number_field.selectedTitleColor = UIColor.black
        phone_number_field.selectedLineColor = Colors.primaryColor
        phone_number_field.selectedLineHeight = 1.5
        phone_number_field.lineHeight = 0.5
        phone_number_field.titleColor = Colors.primaryColor
        phone_number_field.font = UIFont(name: AppConfig.Design.Fonts.regular, size: phone_number_field.font!.pointSize)
        phone_number_field.titleFont = UIFont(name: AppConfig.Design.Fonts.regular, size: phone_number_field.font!.pointSize)!
        
        phone_number_field.delegate = self
    
        phone_number_field.inputAccessoryView = setupDoneButtonOnKeyboard()
        
        
        phone_number_field.placeholder = "Phone number".localized
        
        code_verification_field.keyboardType = .numberPad
        code_verification_field.textColor = UIColor.black
        code_verification_field.lineColor = UIColor.gray
        code_verification_field.selectedTitleColor = UIColor.black
        code_verification_field.selectedLineColor = Colors.primaryColor
        code_verification_field.selectedLineHeight = 1.5
        code_verification_field.lineHeight = 0.5
        code_verification_field.titleColor = Colors.primaryColor
        code_verification_field.font = UIFont(name: AppConfig.Design.Fonts.regular, size: code_verification_field.font!.pointSize)
        code_verification_field.titleFont = UIFont(name: AppConfig.Design.Fonts.regular, size: code_verification_field.font!.pointSize)!
        
        code_verification_field.delegate = self
        
        code_verification_field.inputAccessoryView = setupDoneButtonOnKeyboard()
        
        code_verification_field.placeholder = "Code verification".localized
       
        get_code_btn.setCustomButtonControlStyle(active: false)
        verify_code_btn.setCustomButtonControlStyle(active: true)
        
        stackView_phoneNumber.isHidden = true
        
        code_verification_field_container.isHidden = true
        verify_code_btn_container.isHidden = true
        
    }
    
    func setupView ()  {
        
        
        if let value = SyncAppConfig.findById(id: "USER_PHONE_VERIFICATION"), value.getValue(defaultValue: true) {
            setup_phone_number_component()
        }else{
            stackView_phoneNumber.isHidden = true
        }
       
        
        
        full_name_field.textColor = UIColor.black
        full_name_field.lineColor = UIColor.gray
        full_name_field.selectedTitleColor = UIColor.black
        full_name_field.selectedLineColor = Colors.primaryColor
        full_name_field.selectedLineHeight = 1.5
        full_name_field.lineHeight = 0.5
        full_name_field.titleColor = Colors.primaryColor
        full_name_field.font = UIFont(name: AppConfig.Design.Fonts.regular, size: login_field.font!.pointSize)
        full_name_field.titleFont = UIFont(name: AppConfig.Design.Fonts.regular, size: password_field.font!.pointSize)!
        
        full_name_field.inputAccessoryView = setupDoneButtonOnKeyboard()
        
        
        email_field.textColor = UIColor.black
        email_field.lineColor = UIColor.gray
        email_field.selectedTitleColor = UIColor.black
        email_field.selectedLineColor = Colors.primaryColor
        email_field.selectedLineHeight = 1.5
        email_field.lineHeight = 0.5
        email_field.titleColor = Colors.primaryColor
        email_field.font = UIFont(name: AppConfig.Design.Fonts.regular, size: login_field.font!.pointSize)
        email_field.titleFont = UIFont(name: AppConfig.Design.Fonts.regular, size: password_field.font!.pointSize)!
        
        email_field.inputAccessoryView = setupDoneButtonOnKeyboard()
        
        
        login_field.textColor = UIColor.black
        login_field.lineColor = UIColor.gray
        login_field.selectedTitleColor = UIColor.black
        login_field.selectedLineColor = Colors.primaryColor
        login_field.selectedLineHeight = 1.5
        login_field.lineHeight = 0.5
        login_field.titleColor = Colors.primaryColor
        login_field.font = UIFont(name: AppConfig.Design.Fonts.regular, size: login_field.font!.pointSize)
        login_field.titleFont = UIFont(name: AppConfig.Design.Fonts.regular, size: password_field.font!.pointSize)!
        
        login_field.inputAccessoryView = setupDoneButtonOnKeyboard()
        
        password_field.textColor = UIColor.black
        password_field.lineColor = UIColor.gray
        password_field.selectedTitleColor = UIColor.black
        password_field.selectedLineColor = Colors.primaryColor
        password_field.selectedLineHeight = 1.5
        password_field.lineHeight = 0.5
        password_field.titleColor = Colors.primaryColor
        password_field.font = UIFont(name: AppConfig.Design.Fonts.regular, size: login_field.font!.pointSize)
        password_field.titleFont = UIFont(name: AppConfig.Design.Fonts.regular, size: password_field.font!.pointSize)!
        
        password_field.inputAccessoryView = setupDoneButtonOnKeyboard()
        
        orLabel.initDefaultFont()
        
        orLabel.text = "OR".localized
        full_name_field.placeholder = "Enter full name".localized
        email_field.placeholder = "Enter email address".localized
        login_field.placeholder = "Enter login".localized
        password_field.placeholder = "Enter password".localized
        
        
        full_name_field.delegate = self
        email_field.delegate = self
        login_field.delegate = self
        password_field.delegate = self

        
        pick_photo_btn.backgroundColor = Colors.primaryColor
        pick_photo_btn.setTitle("Pick Photo".localized, for: .normal)
        signUpBtn.setTitle("Sign Up".localized.uppercased(), for: .normal)
        
        
        self.photo_profile.layer.cornerRadius = 5/UIScreen.main.nativeScale
        self.photo_profile.layer.masksToBounds = true
        self.photo_profile.layer.borderColor = Utils.hexStringToUIColor(hex: "#eeeeee").cgColor
        self.photo_profile.clipsToBounds = true
        
        self.pick_photo_btn.backgroundColor = Colors.promoTagColor
        self.pick_photo_btn.setTitleColor(.white, for: .normal)
        self.pick_photo_btn.initDefaultFont()
        

        self.signinBtn.setTitle("Already Have an account?".localized.uppercased(), for: .normal)
        
        
       
        signinBtn.setCustomButtonControlStyle()
        
        signUpBtn.setCustomButtonControlStyle(active: true)
        signUpBtn.setGradientBackground()
      
       
        /*
         Setup Image Profile
         */
        
        self.photo_profile.roundCorners(radius: self.photo_profile.frame.height/2)
        self.photo_profile.layer.borderColor = Utils.hexStringToUIColor(hex: "#eeeeee").cgColor
        self.pick_photo_btn.setTitle("", for: .normal)
        self.pick_photo_btn.roundCorners(radius: self.photo_profile.frame.height/2)
        let camera = UIImage.init(icon:  .linearIcons(.camera), size: CGSize(width: 36, height: 36), textColor: Colors.white).withRenderingMode(.alwaysOriginal)
        self.pick_photo_btn.setImage(camera, for: .normal)
        self.pick_photo_btn.backgroundColor = UIColor.black.withAlphaComponent(0.3)
        
         
    }
    
    
    func setupDoneButtonOnKeyboard() -> UIToolbar
    {
        let doneToolbar: UIToolbar = UIToolbar(frame: CGRect(x:0, y:0, width:320, height:50))
        doneToolbar.barStyle = UIBarStyle.default

     let flexSpace = UIBarButtonItem(barButtonSystemItem: UIBarButtonItem.SystemItem.flexibleSpace, target: nil, action: nil)
     let done: UIBarButtonItem = UIBarButtonItem(title: "Done".localized, style: UIBarButtonItem.Style.done, target: self, action: #selector(doneButtonAction))

        let items = NSMutableArray()
        items.add(flexSpace)
        items.add(done)

        doneToolbar.items = items as? [UIBarButtonItem]
        doneToolbar.sizeToFit()
        
        return doneToolbar
       
    }
    
    @objc func doneButtonAction()
    {
        phone_number_field.resignFirstResponder()
        full_name_field.resignFirstResponder()
        email_field.resignFirstResponder()
        password_field.resignFirstResponder()
        login_field.resignFirstResponder()
        code_verification_field.resignFirstResponder()
    }
    

    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        self.view.endEditing(true)
    }
    
    var lastTextField: UITextField? = nil
    
    func textFieldDidBeginEditing(_ textField: UITextField) {
    
        lastTextField = textField
    }
    
    
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        lastTextField = textField
        return true
    }
    
    
    
    var userLoader: UserLoader = UserLoader()
    func doSignup () {
        
        
        SVProgressHUD.setForegroundColor(Colors.primaryColor)
        SVProgressHUD.setBorderColor(Colors.primaryColor)
        SVProgressHUD.setBackgroundColor(Colors.white)
        SVProgressHUD.setDefaultMaskType(.custom)
        SVProgressHUD.setBackgroundLayerColor( UIColor (white: 1, alpha: CGFloat(0.5))  )
        SVProgressHUD.show()
        
        self.userLoader.delegate = self
        
        
        guard let loginValue = login_field.text else {
            showErros(messages:["login":"Login field is empty".localized])
            return
        }
        
        guard let passwordValue = password_field.text else {
            showErros(messages:["password":"Password field is empty".localized])
            return
        }
        
        guard let emailValue = email_field.text else {
            showErros(messages:["email":"Email field is empty".localized])
            return
        }
        
        guard let nameValue = full_name_field.text else {
            showErros(messages:["name":"Full Name field is empty".localized])
            return
        }
        
        var lat = 0.0
        var lng = 0.0
        var guest_id = 0
        
        if let guest = Guest.getInstance() {
            
            guest_id = guest.id
            lat = guest.lat
            lng = guest.lng
            
        }
        
        
        self.userLoader.load(url: Constances.Api.API_USER_SIGNUP,parameters: [
            "username"  : loginValue,
            "email"     : emailValue,
            "name"      : nameValue,
            "password"  : passwordValue,
            "image"     : imageId,
            "lat"       : String(lat),
            "lng"       : String(lng),
            "guest_id"  : String(guest_id)
            ])
        
    }
    
    func progress_successful()  {
        
        SVProgressHUD.setForegroundColor(Colors.primaryColor)
        SVProgressHUD.setBorderColor(Colors.primaryColor)
        SVProgressHUD.setBackgroundColor(Colors.white)
        SVProgressHUD.setDefaultMaskType(.custom)
        SVProgressHUD.setBackgroundLayerColor( UIColor (white: 1, alpha: CGFloat(0.5))  )
        SVProgressHUD.show()
        SVProgressHUD.showSuccess(withStatus: "Success!".localized)
        
    }
    
    var created_user: User?
    
    func success(parser: UserParser,response: String) {
        
        if parser.success == 1 {
            
          
            let users = parser.parse()
            
            if users.count == 1 {
                
                if let value = SyncAppConfig.findById(id: "USER_PHONE_VERIFICATION"), value.getValue(defaultValue: true) == false {
                    Session.createSession(user: users[0])
                    SwiftEventBus.post("on_main_refresh", sender: users[0])
                }else{
                    self.created_user = users[0]
                }
               
                
                //upload image
                if let image = SignUpViewController.imageProfile{
                   
                    let parameters = [
                        "image":    image.toBase64(),
                        "int_id":   String(users[0].id),
                        "type":     "user",
                        
                        "module":     "user",
                        "module_id":   String(users[0].id),
                    ]
                    
                    let api = SimpleLoader()
                    api.run(url: Constances.Api.API_USER_UPLOAD64, parameters: parameters) { (parser) in
                        if parser?.success == 1{
                            
                        }
                    }
                    
                }
                
                if let value = SyncAppConfig.findById(id: "USER_PHONE_VERIFICATION"), value.getValue(defaultValue: false) == false {
                    
                    if let del = delegate{
                        del.signupSuccess(controller: self, user: users[0])
                    }else{
                         if MainViewController.mInstance != nil {
                            self.dismiss(animated: true)
                        }else{
                            self.startMainVC()
                        }
                    }
                    
                }else{
                    
                    SVProgressHUD.dismiss()
                    self.phone_verification()
                    
                }
           
                
            }else{
                showErros(messages: ["err": "User not found!".localized])
            }
            
            
            
            
        }else {
            
            
            
            if let errors = parser.errors {
                SVProgressHUD.dismiss()
                self.showAlertError(title: "Error",content: errors ,msgBnt: "OK")
            }
            
        }
        
    }
    
    
    func phone_verification()  {
      
        stackView_phoneNumber.isHidden = false
        stackViewUser.isHidden = true
        
    }
    

    
    func error(error: Error?,response: String) {
        
        SVProgressHUD.dismiss()
        
        let errors: [String: String] = [
            "err": "Technical error"
        ]
        
        
        self.showAlertError(title: "Error",content: errors,msgBnt: "OK")
       //
        
    }
    
    
    func showErros(messages: [String: String]) {
        
        self.showAlertError(title: "Error",content: messages,msgBnt: "OK")
        
    }
    

    func startMainVC() {
        
        let sb = UIStoryboard(name: "Main", bundle: nil)
        if let vc = sb.instantiateInitialViewController() {
            self.present(vc, animated: true)
        }
        
    }
    
    static var imageProfile:UIImage? = nil
    
    func imagePickerController(_ picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [UIImagePickerController.InfoKey : Any]) {
// Local variable inserted by Swift 4.2 migrator.
let info = convertFromUIImagePickerControllerInfoKeyDictionary(info)

        
        if let pickedImage = info[convertFromUIImagePickerControllerInfoKey(UIImagePickerController.InfoKey.originalImage)] as? UIImage {
           
            if let imageData = pickedImage.jpeg(.lowest) {
                SignUpViewController.imageProfile = UIImage(data: imageData)
                SignUpViewController.imageProfile = SignUpViewController.imageProfile?.fixOrientation()
                self.photo_profile.contentMode = .scaleAspectFill
                self.photo_profile.image = SignUpViewController.imageProfile
            }
        }
        
        picker.dismiss(animated: true)
        
    }
    
    
  

}

extension UIImage{
    
    enum JPEGQuality: CGFloat {
        case lowest  = 0
        case low     = 0.25
        case medium  = 0.5
        case high    = 0.75
        case highest = 1
    }
    
    /// Returns the data for the specified image in JPEG format.
    /// If the image object’s underlying image data has been purged, calling this function forces that data to be reloaded into memory.
    /// - returns: A data object containing the JPEG data, or nil if there was a problem generating the data. This function may return nil if the image has no data or if the underlying CGImageRef contains data in an unsupported bitmap format.
    func jpeg(_ quality: JPEGQuality) -> Data? {
        return self.jpegData(compressionQuality: quality.rawValue)
    }
    
    public func toBase64() -> String{
        let imageData = self.jpegData(compressionQuality: 1.0)
        return (imageData?.base64EncodedString())!
    }
    
    public func scaleTo(ratio: CGFloat) -> UIImage {
        let size = self.size
        let newSize: CGSize = CGSize(width: size.width  * ratio, height: size.height * ratio)
        let rect = CGRect(x: 0, y: 0, width: newSize.width, height: newSize.height)
        
        // Actually do the resizing to the rect using the ImageContext stuff
        UIGraphicsBeginImageContextWithOptions(newSize, false, 1.0)
        self.draw(in: rect)
        let newImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        return newImage!
    }
    
    public func isEqualToImage(image: UIImage) -> Bool {
        let data1 = self.pngData()
        let data2 = image.pngData()
        return data1 == data2
    }
}


extension UIImage {
    func fixOrientation() -> UIImage {
        if self.imageOrientation == UIImage.Orientation.up {
            return self
        }
        UIGraphicsBeginImageContextWithOptions(self.size, false, self.scale)
        self.draw(in: CGRect(x: 0, y: 0, width: self.size.width, height: self.size.height))
        if let normalizedImage: UIImage = UIGraphicsGetImageFromCurrentImageContext() {
            UIGraphicsEndImageContext()
            return normalizedImage
        } else {
            return self
        }
    }
}


// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromUIImagePickerControllerInfoKeyDictionary(_ input: [UIImagePickerController.InfoKey: Any]) -> [String: Any] {
	return Dictionary(uniqueKeysWithValues: input.map {key, value in (key.rawValue, value)})
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromUIImagePickerControllerInfoKey(_ input: UIImagePickerController.InfoKey) -> String {
	return input.rawValue
}
